library(lpSolve)
#load the lpSolve library into R
data_od<-read.table("D:/Comm_GIS/odtime.txt",header=T)
#This step reads data from odtime.txt into a data frame
data_od<-data_od[order(data_od[,1],data_od[,2]),]
#Sort data first based on origin tract ID, second based on destination tract ID
vec_time<-data_od[,3]
vec_time<-t(vec_time)
#Then convert the third column of the data frame (i.e., od time) to a vector
costs<-matrix(vec_time,nrow=92,ncol=92,byrow=T)
#Convert the above vector to a matrix for subsequent use
data<-read.table("D:/Comm_GIS/wrk_job_inBR_2010.txt",header=T)
#Read the constraints (numbers of resident workers and jobs) from wrk_job_inBR_2010.txt into a data frame
vec_res<-data[,2]
vec_res<-t(vec_res)
#Convert the number of resident workers to vectors
vec_emp<-data[,3]
vec_emp<-t(vec_emp)
#Convert the number of jobs to vectors
row.signs<-rep("=",92)
row.rhs<-vec_res
col.signs<-rep("=",92)
col.rhs<-vec_emp
#Set up constraint signs and right-hand sides
lp.transport(costs,"min",row.signs,row.rhs,col.signs,col.rhs)
#Run to measure the minimum commuting time
result<-data.frame(data_od,as.vector(t(lp.transport(costs,"min",row.signs,row.rhs,col.signs,col.rhs)$solution)),row.names=NULL)
colnames(result)<-c("Oid","Did","Time","Flow")
write.csv(result,file="D:/Comm_GIS/min_comm_time.csv",row.names=F)
#Write solution to a csv file
